﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Data.Odbc;
using System.Windows.Forms;
using System.Diagnostics;

namespace bug67913
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    private void button1_Click(object sender, EventArgs e)
    {
      string queryString = "select * from bug67913 order by col1, col2";
      int i = 0;
      Stopwatch stopWatch = new Stopwatch();
      stopWatch.Start();

      DataTable newTable = new DataTable();
      newTable.TableName = "bug67913";
      OdbcDataReader sReader;

      OdbcConnection connection = new OdbcConnection("DSN=" + textBox1.Text);
      OdbcCommand command = new OdbcCommand(queryString, connection);
      connection.ConnectionTimeout = 60;
      connection.Open();
      sReader = command.ExecuteReader();

      int colCount = sReader.FieldCount;

      for (i = 0; i < colCount; i++)
      {
        newTable.Columns.Add(sReader.GetName(i));
      }

      while (sReader.Read())
      {
        DataRow row = newTable.NewRow();

        for (i = 0; i < colCount; i++)
        {
          row[i] = sReader[i].ToString();
        }
        newTable.Rows.Add(row);
      }

      stopWatch.Stop();
      long elapsed = stopWatch.ElapsedMilliseconds;

      MessageBox.Show("Done!\nResult is " + elapsed.ToString() + " milliseconds");
    }

    private int genInt(int Low, int High)
    {
        Random rndNum = new Random(int.Parse(Guid.NewGuid().ToString().Substring(0, 8), System.Globalization.NumberStyles.HexNumber));
        int rnd = rndNum.Next(Low, High);
        return rnd;
    }

    private string genStr(int len)
    {
      string s1 = "";
      while (s1.Length < len)
      {
        s1 += Guid.NewGuid().ToString();
      }
      return s1.Substring(0, len);
    }


    private void button2_Click(object sender, EventArgs e)
    {
      OdbcConnection connection = new OdbcConnection("DSN=" + textBox1.Text);
      connection.Open();
      OdbcCommand command = new OdbcCommand("DROP TABLE IF EXISTS bug67913", connection);
      command.ExecuteNonQuery();

      command.CommandText = "CREATE TABLE bug67913 (id int primary key auto_increment, col1 varchar(32), col2 int, col3 text, col4 timestamp)";
      command.ExecuteNonQuery();

      int i;

      for (i = 0; i < 50000; i++)
      {
        string cmd_txt = "INSERT INTO bug67913 (id, col1, col2, col3, col4) VALUES (NULL, ";
        cmd_txt += "'" + genStr(30) + "',";
        cmd_txt += genInt(0, 1000000).ToString() + ",";
        cmd_txt += "'" + genStr(512) + "', NOW())";

        command.CommandText = cmd_txt;
        command.ExecuteNonQuery();
      }

      MessageBox.Show("Data created!");
    }
  }
}
